#ifndef MAJTOOLS_MAHJONG_HPP
#define MAJTOOLS_MAHJONG_HPP

#include <map>

enum Pai{
    PAI_INVALID = 0,
    PAI_MAN1 = 0x01,
    PAI_MAN2 = 0x02,
    PAI_MAN3 = 0x03,
    PAI_MAN4 = 0x04,
    PAI_MAN5 = 0x05,
    PAI_MAN6 = 0x06,
    PAI_MAN7 = 0x07,
    PAI_MAN8 = 0x08,
    PAI_MAN9 = 0x09,
    PAI_PIN1 = 0x11,
    PAI_PIN2 = 0x12,
    PAI_PIN3 = 0x13,
    PAI_PIN4 = 0x14,
    PAI_PIN5 = 0x15,
    PAI_PIN6 = 0x16,
    PAI_PIN7 = 0x17,
    PAI_PIN8 = 0x18,
    PAI_PIN9 = 0x19,
    PAI_SOU1 = 0x21,
    PAI_SOU2 = 0x22,
    PAI_SOU3 = 0x23,
    PAI_SOU4 = 0x24,
    PAI_SOU5 = 0x25,
    PAI_SOU6 = 0x26,
    PAI_SOU7 = 0x27,
    PAI_SOU8 = 0x28,
    PAI_SOU9 = 0x29,
    PAI_TON = 0x41,
    PAI_NAN = 0x42,
    PAI_SHA = 0x43,
    PAI_PEI = 0x44,
    PAI_HAKU = 0x81,
    PAI_HATU = 0x82,
    PAI_CHUN = 0x83
};
const Pai PAI_LIST[] = {
    PAI_MAN1, PAI_MAN2, PAI_MAN3, PAI_MAN4, PAI_MAN5, PAI_MAN6, PAI_MAN7, PAI_MAN8, PAI_MAN9,
    PAI_PIN1, PAI_PIN2, PAI_PIN3, PAI_PIN4, PAI_PIN5, PAI_PIN6, PAI_PIN7, PAI_PIN8, PAI_PIN9,
    PAI_SOU1, PAI_SOU2, PAI_SOU3, PAI_SOU4, PAI_SOU5, PAI_SOU6, PAI_SOU7, PAI_SOU8, PAI_SOU9,
    PAI_TON, PAI_NAN, PAI_SHA, PAI_PEI,
    PAI_HAKU, PAI_HATU, PAI_CHUN
};

bool pai_is_valid(int pai);

bool pai_is_man(Pai pai);
bool pai_is_pin(Pai pai);
bool pai_is_sou(Pai pai);
bool pai_is_kaze(Pai pai);
bool pai_is_sangen(Pai pai);

bool pai_is_ji(Pai pai);
bool pai_is_suu(Pai pai);

bool pai_is_yao(Pai pai);
bool pai_is_tan(Pai pai);

int pai_get_number(Pai pai);
bool pai_is_shunstart(Pai pai);
bool pai_is_ryanpenstart(Pai pai);

Pai pai_next_seq(Pai pai);

enum Result{
    RESULT_AGARI, RESULT_TENPAI, RESULT_NONE
};

typedef std::map<int, int> Hand;

Result hand_chk(const Hand& hand);

#endif /* MAJTOOLS_MAHJONG_HPP */
